package com.dsic.gj_erp.util;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;

import java.util.Calendar;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MyString {
    /**
     * 下划线转驼峰
     */
    public static String lineToHump(String str) {
        Pattern linePattern = Pattern.compile("_(\\w)");
        str = str.toLowerCase();
        Matcher matcher = linePattern.matcher(str);
        StringBuffer sb = new StringBuffer();
        while (matcher.find()) {
            matcher.appendReplacement(sb, matcher.group(1).toUpperCase());
        }
        matcher.appendTail(sb);
        return sb.toString();
    }

    public static Integer convertStringToNumber(String str) {
        // 判断字符串是否为 null 或者空字符串
        if (str == null || str.isEmpty()) {
            return null; // 这里返回 null 或者其他逻辑
        }

        // 判断字符串是否为数字
        for (char c : str.toCharArray()) {
            if (!Character.isDigit(c)) {
                return null; // 这里返回 null 或者其他逻辑
            }
        }

        try {
            // 将字符串转换为数字
            return Integer.parseInt(str);
        } catch (NumberFormatException e) {
            e.printStackTrace();
            return null; // 转换失败时返回 null
        }
    }

    /**
     * findtest 个数
     * @param srcText
     * @param findText
     * @return
     */
    public static int appearNumber(String srcText, String findText) {
        int count = 0;
        int index = 0;
        while ((index = srcText.indexOf(findText, index)) != -1) {
            index = index + findText.length();
            count++;
        }
        return count;
    }

    //使用commons的jexl可实现将字符串变成可执行代码的功能

    public static String replace1(String  gs){
        String  replace1=gs;
        if(gs.contains("[")){
            replace1 = gs.replace("[", "s.get");
        }


        if(gs.contains("]d")){
            replace1 = replace1.replace("]d", "().doubleValue()");
        }
        if(gs.contains("]")){
            replace1 = replace1.replace("]", "()");
        }
        if (NumberUtils.isNumber(gs)){
            return gs;
        }
        if (gs.equals("null")){
            return "";
        }
        return replace1;
    }


    public static String subZeroAndDot(String s){

        if(StringUtils.isBlank(s)){
            return null;
        }

        if(s.indexOf(".") > 0){
            s = s.replaceAll("0+?$", "");//去掉多余的0
            s = s.replaceAll("[.]$", "");//如最后一位是.则去掉
        }
        return s;
    }


    /**
     转半角的函数(DBC case)<br/><br/>
     全角空格为12288，半角空格为32
     其他字符半角(33-126)与全角(65281-65374)的对应关系是：均相差65248
     * @param input 任意字符串
     * @return 半角字符串
     *
     */
    public static String ToDBC(String input) {
        char[] c = input.toCharArray();
        for (int i = 0; i < c.length; i++) {
            if (c[i] == 12288) {
                //全角空格为12288，半角空格为32
                c[i] = (char) 32;
                continue;
            }
            if (c[i] > 65280 && c[i] < 65375)
                //其他字符半角(33-126)与全角(65281-65374)的对应关系是：均相差65248
                c[i] = (char) (c[i] - 65248);
        }
        return new String(c);
    }
    /**
     * 两个日期天数差
     * date2比date1多的天数
     * @param date1
     * @param date2
     * @return
     */
    public static int differentDays(Date date1, Date date2)
    {
        Calendar cal1 = Calendar.getInstance();
        cal1.setTime(date1);

        Calendar cal2 = Calendar.getInstance();
        cal2.setTime(date2);
        int day1= cal1.get(Calendar.DAY_OF_YEAR);
        int day2 = cal2.get(Calendar.DAY_OF_YEAR);

        int year1 = cal1.get(Calendar.YEAR);
        int year2 = cal2.get(Calendar.YEAR);
        if(year1 != year2) //同一年
        {
            int timeDistance = 0 ;
            for(int i = year1 ; i < year2 ; i ++)
            {
                if(i%4==0 && i%100!=0 || i%400==0) //闰年
                {
                    timeDistance += 366;
                }
                else //不是闰年
                {
                    timeDistance += 365;
                }
            }

            return timeDistance + (day2-day1) ;
        }
        else //不同年
        {
            System.out.println("判断day2 - day1 : " + (day2-day1));
            return day2-day1;
        }
    }
}
